
#include "Utility.h"
#ifdef _WIN32
    #include "windows.h"
#endif
#include <stdio.h>

#ifdef _WIN32
void curPos(int x, int y) {
  HANDLE hStdout;
  CONSOLE_SCREEN_BUFFER_INFO csbiInfo;
  hStdout=GetStdHandle(STD_OUTPUT_HANDLE);
  GetConsoleScreenBufferInfo(hStdout, &csbiInfo);
  csbiInfo.dwCursorPosition.X=x;
  csbiInfo.dwCursorPosition.Y=y;
  SetConsoleCursorPosition(hStdout, csbiInfo.dwCursorPosition);
}

void clearTerminal() {
    system( "cls" );
}
#endif

void updateTime(SYSTEMTIME *time, FILETIME *timeF, ULONGLONG *time64) {
    GetSystemTime(time);
    SystemTimeToFileTime(time, timeF);
    *time64 = (((ULONGLONG) (*timeF).dwHighDateTime) << 32) + (*timeF).dwLowDateTime;
}

ULONGLONG diffTimeSeconds(ULONGLONG timeStart, ULONGLONG timeEnd) {
    return ((timeEnd-timeStart)/10000000);
}

ULONGLONG diffTimeMilliseconds(ULONGLONG timeStart, ULONGLONG timeEnd) {
    return ((timeEnd-timeStart)/10000);
}

ULONGLONG diffTimeMicroSeconds(ULONGLONG timeStart, ULONGLONG timeEnd) {
    return ((timeEnd-timeStart)/10);
}

unsigned char QKeyPressed() {

#ifdef _WIN32
    if(GetKeyState (0x51) < 0) {     // 'q'
        return 1;
    } else {
        return 0;
    }
#endif

}

unsigned char SpaceKeyPressed() {

#ifdef _WIN32
    if(GetKeyState (VK_SPACE) < 0) {     // spacebar
        return 1;
    } else {
        return 0;
    }
#endif

}

void handleDebugKeys() {

//#ifdef _WIN32
//    if(GetKeyState (0x57) < 0) {     // 'w'
//        if(getNextCommand) {
//            getNextCommand = 0;
//            targetDistThr++;
//            printf("targetDistThr=%f\n", targetDistThr);
//        }
//    } else if(GetKeyState (0x45) < 0) {     // 'e'
//        if(getNextCommand) {
//            getNextCommand = 0;
//            targetDistThr--;
//            printf("targetDistThr=%f\n", targetDistThr);
//        }
//    } else if(GetKeyState (0x52) < 0) {     // 'r'
//        if(getNextCommand) {
//            getNextCommand = 0;
//            maxSpeed++;
//            printf("maxSpeed=%d\n", maxSpeed);
//        }
//    } else if(GetKeyState (0x54) < 0) {     // 't'
//        if(getNextCommand) {
//            getNextCommand = 0;
//            maxSpeed--;
//            printf("maxSpeed=%d\n", maxSpeed);
//        }
//    } else if(GetKeyState (0x5A) < 0) {     // 'z'
//        if(getNextCommand) {
//            getNextCommand = 0;
//            baseSpeed++;
//            printf("baseSpeed=%d\n", baseSpeed);
//        }
//    } else if(GetKeyState (0x55) < 0) {     // 'u'
//        if(getNextCommand) {
//            getNextCommand = 0;
//            baseSpeed--;
//            printf("baseSpeed=%d\n", baseSpeed);
//        }
//    } else if(GetKeyState (0x49) < 0) {     // 'i'
//        if(getNextCommand) {
//            getNextCommand = 0;
//            kRotInit+=0.01;
//            printf("kRotInit=%f\n", kRotInit);
//        }
//    } else if(GetKeyState (0x4F) < 0) {     // 'o'
//        if(getNextCommand) {
//            getNextCommand = 0;
//            kRotInit-=0.01;
//            printf("kRotInit=%f\n", kRotInit);
//        }
//    } else if(GetKeyState (0x41) < 0) {     // 'a'
//        if(getNextCommand) {
//            getNextCommand = 0;
//            highSpeedThr++;
//            printf("highSpeedThr=%f\n", highSpeedThr);
//        }
//    } else if(GetKeyState (0x53) < 0) {     // 's'
//        if(getNextCommand) {
//            getNextCommand = 0;
//            highSpeedThr--;
//            printf("highSpeedThr=%f\n", highSpeedThr);
//        }
//    } else if(GetKeyState (0x44) < 0) {     // 'd'
//        if(getNextCommand) {
//            getNextCommand = 0;
//            lowSpeedThr++;
//            printf("lowSpeedThr=%f\n", lowSpeedThr);
//        }
//    } else if(GetKeyState (0x46) < 0) {     // 'f'
//        if(getNextCommand) {
//            getNextCommand = 0;
//            lowSpeedThr--;
//            printf("lowSpeedThr=%f\n", lowSpeedThr);
//        }
//    } else if(GetKeyState (0x59) < 0) {     // 'y'
//        getNextCommand=1;
//    }
//#endif

}

void printPositionControllerParams() {
//    printf("targetDistThr=%f\n", targetDistThr);
//    printf("maxSpeed=%d\n", maxSpeed);
//    printf("baseSpeed=%d\n", baseSpeed);
//    printf("kRotInit=%f\n", kRotInit);
//    printf("highSpeedThr=%f\n", highSpeedThr);
//    printf("lowSpeedThr=%f\n", lowSpeedThr);
}
